/*
 * Copyright 2013-2018 Radian Memory Systems, Inc.  All Rights Reserved.
 *
 * This file is provided under non-disclosure agreement.
 * See the file COPYING for details.
 */
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#ifdef __BSD_VISIBLE
#include <sys/types.h>
typedef __uint32_t u32;
typedef __uint16_t u16;
typedef __uint8_t u8;
#else
#include <linux/types.h>
#include "nvme_express.h"
#include "nvme_ioctl.h"
typedef __u64 u64;
typedef __u32 u32;
typedef __u16 u16;
typedef __u8 u8;
#endif
#define MAX_DIES 256
#include "RMSVendorSpecific.h"


void
create_generic_uio_pkt(
	struct usr_io *x,
	int direction,
	void *buf,
	unsigned long len)
{
	memset(x, 0x0, sizeof(struct usr_io));
	x->timeout = 1;
	x->direction = direction;
	if (len) {
		x->length = len;
		x->addr = (__u64) buf;
	}
	return;
}

void
append_rms_cmd_pkt(
	struct usr_io *x,
	nvme_cmd_rms200_t *rms)
{
	if (x->direction == XFER_FROM_DEV)
		x->cmd.header.opCode = NVM_RMS_VENDOR_RMS200;
	else
		x->cmd.header.opCode = NVM_RMS_VENDOR_WRITE;
	memcpy(&x->cmd.cmd.vendorSpecific,
		rms,
		sizeof(nvme_cmd_rms200_t));
}

